package es.upm.dit.adsw.tema3.balls.d_narrow_bridge;

public class NB_Monitor_v2 extends NB_Monitor {
    private int nNS = 0;
    private int nSN = 0;

    public synchronized void entraN() {
        while (nSN > 0)
            waiting();
        nNS++;
    }

    public synchronized void entraS() {
        while (nNS > 0)
            waiting();
        nSN++;
    }

    public synchronized void saleN() {
        nSN--;
        notifyAll();
    }

    public synchronized void saleS() {
        nNS--;
        notifyAll();
    }

    private synchronized void waiting() {
        try {
            wait();
        } catch (InterruptedException ignored) {
        }
    }
}
