package es.upm.dit.adsw.tema3.balls.d_narrow_bridge;

public class NB_Monitor_v4 extends NB_Monitor {
    private int nNS = 0;
    private int nSN = 0;
    private int nwN = 0;
    private int nwS = 0;
    private boolean turnoN;

    public synchronized void entraN() {
        nwN++;
        while (nSN > 0 || (turnoN == false && nwS > 0))
            waiting();
        nwN--;
        turnoN = false;
        nNS++;
    }

    public synchronized void entraS() {
        nwS++;
        while (nNS > 0 || (turnoN == true && nwN > 0))
            waiting();
        nwS--;
        turnoN = true;
        nSN++;
    }

    public synchronized void saleN() {
        nSN--;
        notifyAll();
    }

    public synchronized void saleS() {
        nNS--;
        notifyAll();
    }

    private synchronized void waiting() {
        try {
            wait();
        } catch (InterruptedException ignored) {
        }
    }
}
